function Ainv = computeInverse( A )
%  Computing the inverse of A
%  input:  A squared matrix
%  output: Ainv the inverse of A

[m,n] = size(A);

% we need to check that the matrix is squared
if m ~= n
    error('Matrix is not square')
end

%you can allocate the identity matrix 
I_n = eye(n)

% build the augmented matrix
B = [A I_n]

% perform Gaussian elimination (or row reduction)
% to eliminate the entries below the diagonal
for j = 1:n
    
    % you need to check that the matrix is indeed invertible
    if B(j,j) == 0
        error(' The matrix is not invertible')
    end
    
end

% perform Gaussian elimination (or row reduction)
% to eliminate the entries above the diagonal
for j = n:-1:1
    
end

% extracting the inverse from the augmented matrix
Ainv = B(1:n, n+1:2*n);

end
